				;Title("X and Y status")
#include "ti86asm.inc"
.org $d748
	nop
	jp MAIN
	.dw 0
	.dw TI_MAINTITLE
MAIN:
				;	StartExec
	ld hl,$FC00 
	ld (VIDEOBUFF),hl
	call _ram_page_1
	call _clrLCD
	call _runindicoff
				;	DrawString("X:", 10, 10)
	ld hl,TI_STRING0 
	ld (SYSPOINTERARG0),hl
	ld a,10 
	ld (SYSBYTEARG0),a
	ld (SYSBYTEARG1),a
	call DRAWSTRING
				;	DrawString("Y:", sysbytearg0, 20)
	ld hl,TI_STRING1 
	ld (SYSPOINTERARG0),hl
	ld a,20 
	ld (SYSBYTEARG1),a
	call DRAWSTRING
				;	GetRealX
	call GETREALX
				;	DrawNumber(syswordarg0, 20, 10)
	ld a,20 
	ld (SYSBYTEARG0),a
	ld a,10 
	ld (SYSBYTEARG1),a
	call DRAWNUMBER
				;	GetRealY
	call GETREALY
				;	DrawNumber(syswordarg0, sysbytearg0, 20)
	ld a,20 
	ld (SYSBYTEARG1),a
	call DRAWNUMBER
				;	WaitForSecond
	call WAITFORSECOND
				;	EndExec
	call _clrLCD
	ret
				;END
WAITFORSECOND:
    ld bc,$3f20
    call TI_wfsb4
;waits for 2nd to be pressed and released
TI_wfsb2:
    call TI_GETKEY
    or a
    jr nz,TI_wfsb2
TI_wfsb4:
    call TI_GETKEY
    or a
    jr z,TI_wfsb4
    ret
DRAWSTRING:
;draws a string
    ld hl,(SYSBYTEARG0)
    ld (_penCol), hl
    ld hl, (SYSPOINTERARG0)
    jp _vputs
DRAWNUMBER:
;draws a 16-bit number
    ld hl,(SYSBYTEARG0)
    ld (_penCol),hl
    ld hl,(SYSWORDARG0)
    ld de,_OP1+5
    xor a
    ld (de),a
TI_DNLOOP:
    call _divHLby10
    dec de
    add  a,'0'
    ld (de),a
    ld a,h
    or l
    jr nz,TI_DNLOOP
    ex de,hl
    jp _vputs
GETREALX:
	call _rclX
GETREAL_END:
	call _ram_page_1
; first we load $c08a into a (this holds exponent of variable)
	ld hl, 0
	ld a, ($c08a)
	cp 6
	jr nc, GETREAL_ERROR
	ld ix, $c08c
	ld b,a
	inc b
	ld d,$f0
GETREAL_LOOP:
	push bc
	call _mulHL10
	ld e,(ix+0)
	ld a,d
	ld d,$0f
	cp $f0
	jr z, GETREAL_FIRSTBCD
	ld a,$0f
	ld d,$f0
	inc ix
GETREAL_FIRSTBCD:
	and e
	cp 16
	jr c, GETREAL_NOROTATE
	rrca
	rrca
	rrca
	rrca
GETREAL_NOROTATE:
	ld c,a
	ld b,0
	add hl,bc
	pop bc
	djnz GETREAL_LOOP
GETREAL_ERROR:
	ld (SYSWORDARG0), hl
	ld a, l
	ld (SYSBYTEARG0), a
	ret
GETREALY:
	call _rcly
	jr GETREAL_END
TI_CP16:
	push hl
	or a
	sbc hl,de
	pop hl
	ret
;After about three hours of tweaking, I found this to be the most
;stable and effective way to read keys through the hardware (twice)
TI_GETKEY:
	ld a,b
	out (1), a
	in a,(1)
	and c
	ret z
	ld a,b
	out (1), a
	in a,(1)
	and c
	ret
TI_MAINTITLE:
	.db "X and Y status",0
TI_STRING0:
	.db "X:",0
TI_STRING1:
	.db "Y:",0
TI_ENDFILE:
SYSPOINTERARG0                           .equ $8100
SYSPOINTERARG1                           .equ $8102
SYSBYTEARG0                              .equ $8104
SYSBYTEARG1                              .equ $8105
SYSBYTEARG2                              .equ $8106
SYSBYTEARG3                              .equ $8107
SYSBYTEARG4                              .equ $8108
SUCCESS                                  .equ $8109
SPRITE8HEIGHT                            .equ $810a
SPRITE16HEIGHT                           .equ $810b
SYSWORDARG0                              .equ $810c
SYSWORDARG1                              .equ $810e
VIDEOBUFF                                .equ $8110
FREEMEM                                  .equ 33042
SCREENHEIGHT                             .equ 64
NUMSCREENBYTES                           .equ 1024
SCREENWIDTH                              .equ 128
SCREENWIDTHBYTES                         .equ 16
