				;TITLE("TIPwin83 Embedded Library Example")
#include "ionreg.inc"
	.org $9327
	ret
	jr nc,TI_sysbegin
TI_MAINTITLE
	.db "TIPwin83 Embedded Library Example",0
TI_sysbegin:
	jp MAIN
VIDEOBUFF = plotsscreen
MYMESSAGE:
	.db "Hello!",0
	.db "Three Lines", 0
	.db "Will do fine!", 0, 0
MYHELP:
	.db "This isn't really supposed",0
	.db "to be a big help. It's real", 0
	.db "purpose is to debug my new", 0
	.db "function, HelpWindow! It's", 0
	.db "Great! Allows a program to ", 0
	.db "use a list of strings, ", 0
	.db "to create a scrolling help", 0
	.db "window, w/ minimal effort.", 0
	.db "Just write up the document,", 0
	.db "and blam!, there it is!", 0, 0
MYMENU:
	.db 255
	.dw CLEARSCREEN	;this automatically clears the screen before the window is shown
	.db 5		;5 menu options
	.db "Show Big Box", 0
	.db "Plain Gritty Edged", 0
	.db "Sample Message Box", 0
	.db "Using 255-left value", 0
	.db "HelpWindow Function", 0
; These are functions (can be declared later) that are called for each of
; the above menu items. Function Names MUST be in all caps.
	.dw SHOWBIGBOX, PLAINGRITTY, SAMPLEMESSAGE, USING255, DEMONHELP
MAIN:
				;  StartExec
				;  WindowMenu(88, 40, "TIPwin83 Rocks!", mymenu)
	ld a,88 
	ld (SYSBYTEARG2),a
	ld a,40 
	ld (SYSBYTEARG3),a
	ld hl,TI_STRING0 
	ld (SYSPOINTERARG0),hl
	ld hl,MYMENU 
	ld (SYSPOINTERARG1),hl
	call WINDOWMENU
				;  EndExec
	ret
SHOWBIGBOX:
				;  DrawWindowTitleRounded(0,0,96,64, "TIwin83 Big Window")
	xor a ;0 
	ld (SYSBYTEARG0),a
	ld (SYSBYTEARG1),a
	ld a,96 
	ld (SYSBYTEARG2),a
	ld a,64 
	ld (SYSBYTEARG3),a
	ld hl,TI_STRING1 
	ld (SYSPOINTERARG0),hl
	call DRAWWINDOWTITLEROUNDED
				;  CopyBuffer
	call COPYBUFFER
				;  WaitForSecond
	call WAITFORSECOND
	ret
PLAINGRITTY:
				;  DrawWindowPlain(5,5,30,30)
	ld a,5 
	ld (SYSBYTEARG0),a
	ld (SYSBYTEARG1),a
	ld a,30 
	ld (SYSBYTEARG2),a
	ld (SYSBYTEARG3),a
	call DRAWWINDOWPLAIN
				;  CopyBuffer
	call COPYBUFFER
				;  WaitForSecond
	call WAITFORSECOND
	ret
SAMPLEMESSAGE:
				;  MessageBoxCenter(80,28,"Sample",mymessage,MB_OK)
	ld a,80 
	ld (SYSBYTEARG2),a
	ld a,28 
	ld (SYSBYTEARG3),a
	ld hl,TI_STRING2 
	ld (SYSPOINTERARG0),hl
	ld hl,MYMESSAGE 
	ld (SYSPOINTERARG1),hl
	ld a,MB_OK 
	ld (SYSBYTEARG4),a
	call MESSAGEBOXCENTER
	ret
USING255:
				;  DrawWindowTitleRounded(255,16,32,32,"Middle")
	ld a,255 
	ld (SYSBYTEARG0),a
	ld a,16 
	ld (SYSBYTEARG1),a
	ld a,32 
	ld (SYSBYTEARG2),a
	ld (SYSBYTEARG3),a
	ld hl,TI_STRING3 
	ld (SYSPOINTERARG0),hl
	call DRAWWINDOWTITLEROUNDED
				;  CopyBuffer
	call COPYBUFFER
				;  WaitForSecond
	call WAITFORSECOND
	ret
DEMONHELP:
				;  ClearScreen
	call CLEARSCREEN
				;  HelpWindow("TIPwin83 Help", myhelp)
	ld hl,TI_STRING4 
	ld (SYSPOINTERARG0),hl
	ld hl,MYHELP 
	ld (SYSPOINTERARG1),hl
	call HELPWINDOW
	ret
				;END
CLEARSCREEN:
;clears the home screen
    ld hl, VIDEOBUFF
    ld de, VIDEOBUFF+1
    ld (hl),0
    ld bc, NUMSCREENBYTES-1
    ldir
    jp ionFastCopy
COPYBUFFER .equ ionFastCopy
WAITFORSECOND:
;waits for 2nd to be pressed and released
    call TI_wfsb4
TI_wfsb2:
    call TI_wfsb3
    jr nz,TI_wfsb2
TI_wfsb4:
    call TI_wfsb3
    jr z,TI_wfsb4
    ret
TI_wfsb3:
    ld a, $ff
    out (1),a
    ld a, $bf
    out (1),a
    in a,(1)
    cp 223
    ret
; refer to DRAWWINDOW in TIPwin83.asm
; This is the FIRST external library for TIPower!
;  NOTE: This library has little interest in speed (it's still kinda fast, but doesn't waste space
;                                                   to make it lightning)
; There are 8 functions included within the library..
;   DrawWindowRounded(sysbytearg0 = top, sysbytearg1=left, sysbytearg2=width, sysbytearg3=height)
;       Draws a nice-looking window with rounded corners. Width and Height both must be
;       at least 5. Anything less will yield graphical errors
;   DrawWindowPlain
;       Same as above except with square corners
;   DrawWindowTitleRounded(same as above..., syspointerarg0 = titlestring)
;       This performs the same as above except it draws a nice title bar. height must be 10 though.
;   DrawWindowTitlePlain ... etc.etc.
;   MessageBox(top, left, width, height, syspointerarg0 = title, syspointerarg1=messagestrings, sysbytearg4 = type)
;   MessageBoxCenter(width, height, title, messagestrings, type)
;           VALID TYPES:
;               MB_NONE (Doesn't wait for user input)
;               MB_OK   ('2nd' button used to quit)
;               MB_YESNO (Press '2nd' then SUCCESS=IDYES, Alpha = IDNO)
;               MB_YESNOCANCEL (2nd=IDYES, alpha=IDNO, exit=IDCANCEL)
;           Determining Message Box Height : height = 10 + numlines * 6
;   HelpBox(title, messagestrings)
;           One of handiest of the functions, this will display multiple pages of info
;           in a window, and the user can use 2nd and alpha to scroll up and down, and exit to leave.
;   WindowMenu(width, height, title, syspointerarg1 = menudata)
;           This is THE handiest function in the library!
;           Menu data is in the following format:
;               .db number of menu options
;               .db null-terminating strings (for each menu option's text)
;               .dw functionnames (corresponding to the strings) in ALL CAPS
; *************************************************************************************************
DRAWWINDOWROUNDED: ; 123 bytes!
    call LIBTI_FINDPIXEL       ;hl now equals video memory location
                            ;(accounting for buffer as well) and a is the bit
;first we draw our top line:
    call DRAWWINDOW_HORZLINE ;draw the top line
    call DRAWWINDOW_FILLTYPE1 ;and make rounded corner..
    ld bc, (SYSBYTEARG2)    ;we need the height - 4 to account for top and bottom lines
    dec b
    dec b                   ;we need to keep value in 'a'. This is the fastest
    dec b                   ;method possible without losing it.
    dec b    
DRAWWINDOWROUNDED_MAINLOOP:
    push bc
    call DRAWWINDOW_FILLTYPE2   ;fill in height-4 lines
    pop bc
    djnz DRAWWINDOWROUNDED_MAINLOOP
    call DRAWWINDOW_FILLTYPE1 ;draw bottom rounded corner
    jp DRAWWINDOW_HORZLINE    ; and bottom line (jump because we are done!)
DRAWWINDOWPLAIN:
    CALL LIBTI_FINDPIXEL
    CALL DRAWWINDOW_FULLLINE
    ld bc, (SYSBYTEARG2)
    dec b
    dec b
DRAWWINDOWPLAIN_MAINLOOP:
    push bc
    call DRAWWINDOW_FILLTYPE2
    pop bc
    djnz DRAWWINDOWPLAIN_MAINLOOP
    jp DRAWWINDOW_FULLLINE
; Draw Window Subroutines
DRAWWINDOW_HORZLINE:
    push hl
    ld e, a
    call DWSKIPAPIXEL ;this skips one pixel ahead. source at bottom of this section
    call DWSKIPAPIXEL ;we skip pixels so underneath the window looks neater.
    ld bc, (SYSBYTEARG1)
    dec b
    dec b
    dec b
    dec b
DRAWWINDOW_HORZLINE_LOOP:
    CALL DWDRAWAPIXEL
    djnz DRAWWINDOW_HORZLINE_LOOP
DRAWWINDOW_COM_ENDING:    ;all the DRAWWINDOW line routines end with this ending
    ld a,e
    ld de, 12
    pop hl
    add hl,de             ;go to the next row
    ret
DRAWWINDOW_FILLTYPE1:
    push hl
    ld e, a
    call DWSKIPAPIXEL
    call DWDRAWAPIXEL
    ld bc, (SYSBYTEARG1)
    dec b
    dec b
    dec b
    dec b
DRAWWINDOW_FILLTYPE1_LOOP:
    call DWERASEAPIXEL
    djnz DRAWWINDOW_FILLTYPE1_LOOP
    call DWDRAWAPIXEL
    jp DRAWWINDOW_COM_ENDING
DRAWWINDOW_FILLTYPE2:
    push hl
    ld e, a
    call DWDRAWAPIXEL
    ld bc, (SYSBYTEARG1)
    dec b
    dec b
DRAWWINDOW_FILLTYPE2_LOOP:
    call DWERASEAPIXEL
    djnz DRAWWINDOW_FILLTYPE2_LOOP
    call DWDRAWAPIXEL
    jp DRAWWINDOW_COM_ENDING
DRAWWINDOW_FILLTYPE3:
    push hl
    ld e, a
    call DWSKIPAPIXEL
    ld bc, (SYSBYTEARG1)
    dec b
    dec b
DRAWWINDOW_FILLTYPE3_LOOP:
    call DWDRAWAPIXEL
    djnz DRAWWINDOW_FILLTYPE3_LOOP
    jp DRAWWINDOW_COM_ENDING    
DRAWWINDOW_FULLLINE:
    push hl
    ld e,a
    ld bc, (SYSBYTEARG1)
DRAWWINDOW_FULLLINE_LOOP:
    call DWDRAWAPIXEL
    djnz DRAWWINDOW_FULLLINE_LOOP
    jp DRAWWINDOW_COM_ENDING
; there's something here everyone should pay attention to. notice I have DWDRAWAPIXEL jump
; back to finish at DWSKIPAPIXEL, and DWERASEAPIXEL gets the speed advantage by running straight
; into it. It gets this because in window drawing there is a LOT more erasing going on than pixel
; drawing. You gotta keep this stuff in mind when you are optimizing!
DWERASEAPIXEL:
    ld d,a
    cpl
    and (hl)
    ld (hl),a
    ld a,d
DWSKIPAPIXEL:
    rrca
    ret nc
    inc hl
    ret
DWDRAWAPIXEL:
    ld d,a
    or (hl)
    ld (hl),a
    ld a,d
    jp DWSKIPAPIXEL
;**************************************************************************************************
DRAWWINDOWTITLEROUNDED:
    set textwrite, (iy + sgrflags)
    call LIBTI_FINDPIXEL       ;hl now equals video memory location
                            ;(accounting for buffer as well) and a is the bit
;first we draw our top line:
    call DRAWWINDOW_HORZLINE ;draw the top line
    call DRAWWINDOW_FILLTYPE3 ;and make rounded corner..
    ld b,5
DRAWWINDOWTITLEROUNDED_MAINLOOPA:
    push bc
    call DRAWWINDOW_FULLLINE
    pop bc
    djnz DRAWWINDOWTITLEROUNDED_MAINLOOPA
    push af
    ld a, (SYSBYTEARG3)    ;we need the height - 4 to account for top and bottom lines
    sub 9
    ld b,a    
    pop af
DRAWWINDOWTITLEROUNDED_MAINLOOPB:
    push bc
    call DRAWWINDOW_FILLTYPE2   ;fill in height-4 lines
    pop bc
    djnz DRAWWINDOWTITLEROUNDED_MAINLOOPB
    call DRAWWINDOW_FILLTYPE1 ;draw bottom rounded corner
    call DRAWWINDOW_HORZLINE    ; and bottom line (jump because we are done!)    call DRAWWINDOWROUNDED
FINISH_WINDOWTITLE:
    ld de,(SYSBYTEARG0)
    inc e
    inc e
    inc e
    ld hl,(SYSPOINTERARG0)
    ld (penCol), de
    ld a,(iy+textflags) ;saves whether the text inversion is on right now
    set textInverse,(iy+textflags) ; turns on text inversion
    bcall _vputs
    ld (iy+textflags),a ;reload our old settings
    res textwrite, (iy + sgrflags)
    ret
DRAWWINDOWTITLEPLAIN:
    set textwrite, (iy + sgrflags)
    call LIBTI_FINDPIXEL       ;hl now equals video memory location
                            ;(accounting for buffer as well) and a is the bit
;first we draw our top line:
    call DRAWWINDOW_FULLLINE ;draw the top line.
    ld b,6
DRAWWINDOWTITLEPLAIN_MAINLOOPA:
    push bc
    call DRAWWINDOW_FULLLINE
    pop bc
    djnz DRAWWINDOWTITLEPLAIN_MAINLOOPA
    push af
    ld a, (SYSBYTEARG3)    ;we need the height
    sub 8
    ld b,a    
    pop af
DRAWWINDOWTITLEPLAIN_MAINLOOPB:
    push bc
    call DRAWWINDOW_FILLTYPE2   ;fill in height-4 lines
    pop bc
    djnz DRAWWINDOWTITLEPLAIN_MAINLOOPB
    call DRAWWINDOW_FULLLINE ; and bottom line (jump because we are done!)
    jr FINISH_WINDOWTITLE
;**************************************************************************************************
#define LIBIDYES 1
#define LIBIDNO 2
#define LIBIDCANCEL 3
#define LIBIDUP 4
#define LIBIDDOWN 5
#define LIBMB_OK 0
#define LIBMB_YESNO 1
#define LIBMB_YESNOCANCEL 2
#define LIBMB_NONE 3
MESSAGEBOX:  ;92 bytes (for all message-box functions)
    CALL DRAWWINDOWTITLEROUNDED
    set textwrite, (iy + sgrflags)
    ld de,(SYSBYTEARG0)
    ld hl,515
    add hl,de
    ex de,hl
    ld hl,(SYSPOINTERARG1)
MESSAGEBOX_MAINLOOP:
    ld a,d
    add a,6
    ld d,a
    ld (penCol), de
    bcall _vputs
    ld a,(hl)
    or a
    jr nz,MESSAGEBOX_MAINLOOP
    ld a,(SYSBYTEARG4)
    cp LIBMB_NONE
    ret z
    call ionFastCopy
    cp LIBMB_OK
    jr z, MESSAGEBOX_MB_OK
    cp LIBMB_YESNO
    jr z, MESSAGEBOX_MB_YESNO
MESSAGE_MB_YESNOCANCELLOOP:
    call TIPwin86KEYS
    ld a,b
    or a
    jr z, MESSAGE_MB_YESNOCANCELLOOP
MESSAGEBOX_COM_END:
    ld (SUCCESS), a
MESSAGEBOX_COM_END_LOOP:
    call TIPwin86KEYS
    ld a,b
    or a
    jr nz, MESSAGEBOX_COM_END_LOOP
    res textwrite, (iy + sgrflags)
    ret
MESSAGEBOX_MB_OK:
    call TIPwin86KEYS
    ld a,b
    cp LIBIDYES
    jr nz,MESSAGEBOX_MB_OK
    jr MESSAGEBOX_COM_END
MESSAGEBOX_MB_YESNO
    call TIPwin86KEYS
    ld a,b
    cp LIBIDCANCEL
    jr z,MESSAGEBOX_MB_YESNO
    or a
    jr z,MESSAGEBOX_MB_YESNO
    jr MESSAGEBOX_COM_END
MESSAGEBOXCENTER:
    ld a,255
    ld (SYSBYTEARG0), a
    jr MESSAGEBOX
;**************************************************************************************************
HELPWINDOW: ;pretty nice for 179 bytes!
    call MESSAGEBOX_COM_END_LOOP
    ld hl,(SYSPOINTERARG1)
    ld (HELPWINDOW_FIRSTLINE),hl
    ld hl,$0000
    ld (SYSBYTEARG0), hl
    ld hl,$4060
    ld (SYSBYTEARG2), hl
    CALL DRAWWINDOWTITLEROUNDED
    set textwrite, (iy + sgrflags)
HELPWINDOW_DRAW:
    ld de,$0203
    ld b,8
    ld hl,(SYSPOINTERARG1)
HELPWINDOWBOX_MAINLOOP:
    call HELPWINDOW_INITNEXTLINE
    bcall _vputs
    ld a,b
    cp 8
    jr nz, HELPWINDOW_NOSETNEXT
    ld (HELPWINDOW_NEXTLINE),hl
HELPWINDOW_NOSETNEXT:
    ld (HELPWINDOW_LASTLINE),hl
    ld a,(hl)
    or a
    jr z,HELPWINDOW_MAINLOOP_EXIT
    djnz HELPWINDOWBOX_MAINLOOP
HELPWINDOW_MAINLOOP_EXIT:
    call HELPWINDOW_INITNEXTLINE
    call ionFastCopy
HELPWINDOW_MAINLOOP_EXITLOOP:
    call TIPwin86KEYS
    ld hl, HELPWINDOW_DRAW
    push hl
    ld a,b
    cp LIBIDUP
    jr z, HELPWINDOW_GOUP
    cp LIBIDDOWN
    jr z, HELPWINDOW_GODOWN
    pop hl
    cp LIBIDCANCEL
    jr nz, HELPWINDOW_MAINLOOP_EXITLOOP
    res textwrite, (iy + sgrflags)
    ret
HELPWINDOW_GOUP:
    ld hl,(SYSPOINTERARG1)
    ld de,(HELPWINDOW_FIRSTLINE)
    call LIBTI_CP16
    ret z
    dec hl
    dec de
HELPWINDOW_GOUPLOOP:
    ld (SYSPOINTERARG1),hl
    dec hl
    ld a,(hl)
    or a
    ret z
    CALL LIBTI_CP16
    ret z
    jr HELPWINDOW_GOUPLOOP
HELPWINDOW_GODOWN:
    ld hl,(HELPWINDOW_NEXTLINE)
    ld de,(HELPWINDOW_LASTLINE)
    call LIBTI_CP16
    ret z    
    ld (SYSPOINTERARG1), hl
    ret
HELPWINDOW_INITNEXTLINE:
    ld a,d
    add a,6
    ld d,a
    ld (penCol), de
HELPWINDOW_ERASELINE:
    push hl
    push de
    push bc
    ld l,d
    ld h,0
    add hl,hl
    add hl,hl
    push hl
    pop de
    add hl,hl
    add hl,de
    ld de, plotsscreen
    add hl,de
    ex de,hl
    ld a,6
HELPWINDOW_ERASELINE_LOOP:
    ld hl,HELPWINDOW_ERASELINE_DATA
    ld bc,12
    ldir
    dec a
    jr nz, HELPWINDOW_ERASELINE_LOOP
    pop bc
    pop de
    pop hl
    ret
HELPWINDOW_ERASELINE_DATA:
    .db 128,0,0,0,0,0,0,0,0,0,0,1
HELPWINDOW_FIRSTLINE:
    .dw 0
HELPWINDOW_NEXTLINE:
    .dw 0
HELPWINDOW_LASTLINE:
    .dw 0
;**************************************************************************************************
WINDOWMENU: ;worth every 201 bytes! 
    ld hl, SYSBYTEARG0
    ld a,255
    ld (hl), a
    ld hl, SYSPOINTERARG0
    ld de, WINDOWMENU_ARGUMENTDATA
    call WINDOWMENU_LDIR
WINDOWMENU_MAIN:
    call MESSAGEBOX_COM_END_LOOP	; makes sure a key isn't being pressed
    ld de,SYSPOINTERARG0
    ld hl,WINDOWMENU_ARGUMENTDATA
    call WINDOWMENU_LDIR
    ld hl,(SYSPOINTERARG1)
    ld a,(hl)
    cp 255
    call z, WINDOWMENU_INITIALIZATIONFUNCTION
    ld (SYSPOINTERARG1), hl
    call DRAWWINDOWTITLEROUNDED
    set textwrite, (iy + sgrflags)
    ld hl,(SYSPOINTERARG1)
    ld a,(hl)
    inc hl
    ld b,a
    dec a
    ld (WINDOWMENU_NUMOPTIONS), a
    push hl
    ld de, (SYSBYTEARG0)
    push de
    ld hl, 521
    add hl,de
    ex de,hl
    pop ix
    pop hl
    push ix
WINDOWMENU_DRAWLOOP:
    ld a,d
    add a,6
    ld d,a
    ld (penCol), de
    bcall _vputs
    djnz WINDOWMENU_DRAWLOOP
    ld a,(hl)
    cp 255
    call z, WINDOWMENU_INITIALIZATIONFUNCTION
    push hl
    pop ix
    pop de
    ld hl,$0804
    add hl,de
    ex de,hl
    xor a
    ld (WINDOWMENU_CURSELECT), a
WINDOWMENU_MAINLOOP:
    ld (penCol),de
    ld hl,WINDOWMENU_CURSOR
    push de
    bcall _vputs
    call ionFastCopy
WINDOWMENU_KEYLOOP
    call TIPwin86KEYS
    ld a,b
    or a
    jr z,WINDOWMENU_KEYLOOP
    pop de
    push bc
    push de
    ld (penCol),de
    ld hl, WINDOWMENU_CURSORERASE
    bcall _vputs
WINDOWMENU_KEYLOOP2
    call TIPwin86KEYS
    ld a,b
    or a
    jr nz,WINDOWMENU_KEYLOOP2
    pop de
    pop af
    ld hl,WINDOWMENU_CURSELECT
    cp LIBIDUP
    jr z,WINDOWMENU_GOUP
    cp LIBIDDOWN
    jr z,WINDOWMENU_GODOWN
    cp LIBIDYES
    jr z,WINDOWMENU_SELECT
    cp LIBIDCANCEL
    jr nz, WINDOWMENU_MAINLOOP
    res textwrite, (iy + sgrflags)
    ret
WINDOWMENU_GOUP:
    ld a,(hl)
    or a
    jr z, WINDOWMENU_MAINLOOP
    dec (hl)
    ld a,d
    sub 6
    ld d,a
    jr WINDOWMENU_MAINLOOP
WINDOWMENU_GODOWN:
    ld a,(WINDOWMENU_NUMOPTIONS)
    cp (hl)
    jr z, WINDOWMENU_MAINLOOP
    inc (hl)
    ld a,d
    add a,6
    ld d,a
    jr WINDOWMENU_MAINLOOP
WINDOWMENU_SELECT:
    ld a,(hl)
    rlca
    push ix
    pop de
    ld l,a
    ld h,0
    add hl,de
    ld e,(hl)
    inc hl
    ld d,(hl)
    ld hl,WINDOWMENU_MAIN
    push hl
    push de
    ret
WINDOWMENU_LDIR:
    ld bc, 8
    ldir
    ret
WINDOWMENU_INITIALIZATIONFUNCTION:
	inc hl
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	push hl
	ld (WINDOWMENU_INITIALIZATIONMORPHIC+1), de
WINDOWMENU_INITIALIZATIONMORPHIC
	call $0000
	pop hl
	ret
WINDOWMENU_CURSELECT:
    .db 0
WINDOWMENU_NUMOPTIONS:
    .db 0
WINDOWMENU_CURSOR:
    .db 5, 0
WINDOWMENU_CURSORERASE:
    .db "    ", 0
WINDOWMENU_ARGUMENTDATA:
    .db 0,0,0,0,0,0,0,0
;**************************************************************************************************
TIPwin86KEYS:
    ld d, 2
TIPwin86KEYS_LOOP:
    ld b, LIBIDYES
    ld hl,$bf20
    call LIBTI_GETKEY
    ret z
    ld b, LIBIDCANCEL
    ld hl,$bf40
    call LIBTI_GETKEY
    ret z
    ld b, LIBIDNO
    ld hl,$df80
    call LIBTI_GETKEY
    ret z
    ld b, LIBIDUP
    ld hl,$fe08
    call LIBTI_GETKEY
    ret z
    ld b, LIBIDDOWN
    ld hl,$fe01
    call LIBTI_GETKEY
    ret z
    dec d
    jr nz, TIPwin86KEYS_LOOP
    ld b,0
    ret
LIBTI_GETKEY:
	ld a, $ff
	out (1), a
	ld a, h
	out (1), a
	in a, (1)
	and l
	ret z
	ld a, $ff
	out (1), a
	ld a, h
	out (1), a
	in a, (1)
	and l
	ret
LIBTI_CP16:
    push hl
    or a
    sbc hl,de
    pop hl
    ret    
; required TIPower System Function
LIBTI_FINDPIXEL:
; first we check if width = 255 (if it does, we center the box in the screen)
  ld de,(SYSBYTEARG0)
  ld a, e
  cp 255
  jr nz, START_TI_FINDPIXEL
    ; calculate and assign appropriate values
  ld hl,(SYSBYTEARG2)    ;get width, height
  sra h                 ;divide both by two
  sra l
  ld a,48       ;get correct left value ( 48 - width / 2)
  sub l
  ld l,a
  ld a,32       ;get correct top value ( 32 - height / 2)
  sub h
  ld h,a
  ld (SYSBYTEARG0), hl
  ex de,hl
START_TI_FINDPIXEL:
; typical find pixel routine
    ld a,e
    ld e,d
    sla e
    sla e
    ld h,0
    ld d,h
    ld l,e
    add hl,hl
    add hl,de
    ld e,a
    srl e
    srl e
    srl e
    add hl,de
    ld bc, plotsscreen
    add hl,bc   ; Add address to graphbuf
    and %00000111
    ld e,a
    push hl
    ld hl, LIBTI_FP_Bits
    add hl,de
    ld a,(hl)
    pop hl
    ret
LIBTI_FP_Bits: .db $80,$40,$20,$10,$08,$04,$02,$01
; refer to DRAWWINDOW in TIPwin83.asm
; refer to DRAWWINDOW in TIPwin83.asm
; refer to HELPWINDOW in TIPwin83.asm
; refer to WINDOWMENU in TIPwin83.asm
TI_CP16:
	push hl
	or a
	sbc hl,de
	pop hl
	ret
;After about three hours of tweaking, I found this to be the most
;stable and effective way to read keys through the hardware (twice)
TI_GETKEY:
	ld a, $ff
	out (1), a
	ld a, b
	out (1), a
	in a, (1)
	and c
	ret z
	ld a, $ff
	out (1), a
	ld a, b
	out (1), a
	in a, (1)
	and c
	ret
TI_STRING0:
	.db "TIPwin83 Rocks!",0
TI_STRING1:
	.db "TIwin83 Big Window",0
TI_STRING2:
	.db "Sample",0
TI_STRING3:
	.db "Middle",0
TI_STRING4:
	.db "TIPwin83 Help",0
TI_ENDFILE:
SYSWORDARG1                              .equ $b7fe
SYSWORDARG0                              .equ $b7fc
SPRITE16HEIGHT                           .equ $b7fb
SPRITE8HEIGHT                            .equ $b7fa
SUCCESS                                  .equ $b7f9
SYSBYTEARG4                              .equ $b7f8
SYSBYTEARG3                              .equ $b7f7
SYSBYTEARG2                              .equ $b7f6
SYSBYTEARG1                              .equ $b7f5
SYSBYTEARG0                              .equ $b7f4
SYSPOINTERARG1                           .equ $b7f2
SYSPOINTERARG0                           .equ $b7f0
FREEMEM                                  .equ 47088
SCREENHEIGHT                             .equ 64
NUMSCREENBYTES                           .equ 768
SCREENWIDTH                              .equ 96
SCREENWIDTHBYTES                         .equ 12
IDYES                                    .equ 1
IDNO                                     .equ 2
IDCANCEL                                 .equ 3
MB_OK                                    .equ 0
MB_YESNO                                 .equ 1
MB_YESNOCANCEL                           .equ 2
MB_NONE                                  .equ 3
