				;TITLE("TIPwin86 Library Example")
#include "ti86asm.inc"
.org $d748
	nop
	jp MAIN
	.dw 0
	.dw TI_MAINTITLE
#include "TIPwin86.inc"
TIPWIN86:
	.db 0,8,"TIPwin86"
MYSPRITE:
	.db %11111111, %11111111
	.db %10000000, %00000001
	.db %10111111, %11111101
	.db %10100000, %00000101
	.db %10101111, %11110101
	.db %10101000, %00010101
	.db %10101011, %11010101
	.db %10101010, %01010101
	.db %10101010, %01010101
	.db %10101011, %11010101
	.db %10101000, %00010101
	.db %10101111, %11110101
	.db %10100000, %00000101
	.db %10111111, %11111101
	.db %10000000, %00000001
	.db %11111111, %11111111
MYMESSAGE:
	.db "Hello!",0
	.db "Three Lines", 0
	.db "Will do fine!", 0, 0
MYHELP:
	.db "This isn't particularly supposed",0
	.db "to be a big help. It's real", 0
	.db "purpose is to debug my new", 0
	.db "function, HelpWindow! It's", 0
	.db "Great! Allowing any program to", 0
	.db "use a list of strings, like this", 0
	.db "one, to create a scrolling help", 0
	.db "window, with minimal effort. You", 0
	.db "just write up the help document,", 0
	.db "and blam!, there it is!", 0, 0
MYMENU:
	.db 255
	.dw CLEARSCREEN	;this automatically clears the screen before the window is shown
	.db 5		;5 menu options
	.db "Show Big Box", 0
	.db "Plain Gritty Edged", 0
	.db "Sample Message Box", 0
	.db "Using 255-left value", 0
	.db "HelpWindow Function", 0
; These are functions (can be declared later) that are called for each of
; the above menu items. Function Names MUST be in all caps.
	.dw SHOWBIGBOX, PLAINGRITTY, SAMPLEMESSAGE, USING255, DEMONHELP
MAIN:
				;  StartExec
	ld hl,$FC00 
	ld (VIDEOBUFF),hl
	call _ram_page_1
	call _clrLCD
	call _runindicoff
				;  LoadLibrary(TIPwin86, TIPwin86size)
	ld hl,TIPWIN86 
	ld (SYSPOINTERARG0),hl
	ld hl,TIPWIN86SIZE 
	ld (SYSWORDARG0),hl
	call LOADLIBRARY
				;  WindowMenu(100, 40, "TIPwin86 Rocks!", mymenu)
	ld a,100 
	ld (SYSBYTEARG2),a
	ld a,40 
	ld (SYSBYTEARG3),a
	ld hl,TI_STRING0 
	ld (SYSPOINTERARG0),hl
	ld hl,MYMENU 
	ld (SYSPOINTERARG1),hl
	call WINDOWMENU
				;  EndExec
	call _clrLCD
	ret
SHOWBIGBOX:
				;  DrawWindowTitlePlain(0,0,128,64,TI_MAINTITLE)
	xor a ;0 
	ld (SYSBYTEARG0),a
	ld (SYSBYTEARG1),a
	ld a,128 
	ld (SYSBYTEARG2),a
	ld a,64 
	ld (SYSBYTEARG3),a
	ld hl,TI_MAINTITLE 
	ld (SYSPOINTERARG0),hl
	call DRAWWINDOWTITLEPLAIN
				;  WaitForSecond
	call WAITFORSECOND
	ret
PLAINGRITTY:
				;  DrawWindowPlain(5,5,30,30)
	ld a,5 
	ld (SYSBYTEARG0),a
	ld (SYSBYTEARG1),a
	ld a,30 
	ld (SYSBYTEARG2),a
	ld (SYSBYTEARG3),a
	call DRAWWINDOWPLAIN
				;  Draw1616(mysprite, 10, 10)
	ld hl,MYSPRITE 
	ld (SYSPOINTERARG0),hl
	ld a,10 
	ld (SYSBYTEARG0),a
	ld (SYSBYTEARG1),a
	call DRAW1616
				;  WaitForSecond
	call WAITFORSECOND
	ret
SAMPLEMESSAGE:
				;  MessageBoxCenter(80,28,"Sample",mymessage,MB_OK)
	ld a,80 
	ld (SYSBYTEARG2),a
	ld a,28 
	ld (SYSBYTEARG3),a
	ld hl,TI_STRING1 
	ld (SYSPOINTERARG0),hl
	ld hl,MYMESSAGE 
	ld (SYSPOINTERARG1),hl
	ld a,MB_OK 
	ld (SYSBYTEARG4),a
	call MESSAGEBOXCENTER
	ret
USING255:
				;  DrawWindowTitleRounded(255,16,32,32,"Middle")
	ld a,255 
	ld (SYSBYTEARG0),a
	ld a,16 
	ld (SYSBYTEARG1),a
	ld a,32 
	ld (SYSBYTEARG2),a
	ld (SYSBYTEARG3),a
	ld hl,TI_STRING2 
	ld (SYSPOINTERARG0),hl
	call DRAWWINDOWTITLEROUNDED
				;  WaitForSecond
	call WAITFORSECOND
	ret
DEMONHELP:
				;  ClearScreen
	call CLEARSCREEN
				;  HelpWindow("TIPwin86 Help", myhelp)
	ld hl,TI_STRING3 
	ld (SYSPOINTERARG0),hl
	ld hl,MYHELP 
	ld (SYSPOINTERARG1),hl
	call HELPWINDOW
	ret
				;END
CLEARSCREEN:
;clears the home screen
    ld hl,$fc00
    ld de, $fc01
    ld (hl),l
    ld bc,1023
    ldir
    ret
WAITFORSECOND:
    ld bc,$3f20
    call TI_wfsb4
;waits for 2nd to be pressed and released
TI_wfsb2:
    call TI_GETKEY
    or a
    jr nz,TI_wfsb2
TI_wfsb4:
    call TI_GETKEY
    or a
    jr z,TI_wfsb4
    ret
LOADSTRING:
;loads a string from memory
    ld hl,(SYSWORDARG0)
    push hl
    ld hl,(SYSPOINTERARG1)
    push hl
    ld hl,(SYSPOINTERARG0)
    rst 20h
    rst 10h
    jr c, TI_LSERROR
    ld a,b
    ex de,hl
    call _ahl_plus_2_pg3
    call _set_abs_src_addr
    pop hl
    ld a,h
    sub $80
    ld h,a
    ld a,1
    call _set_abs_dest_addr
    pop hl
    xor a
    call _set_mm_num_bytes
    call _mm_ldir
    xor a
TI_LOADSTRING_FINISH:
    push af
    call _ram_page_1
    pop af
    ld (SUCCESS),a
    ret
TI_LSERROR:
    pop hl
    pop hl
    ld a,1
    jr TI_LOADSTRING_FINISH
LOADLIBRARY:
;loads a library into the last 4k of the RAM_PAGE_1 (assuming 14k is alterable)
    ld hl, $A900
    ld (SYSPOINTERARG1),hl
    call LOADSTRING
    ld a, (SUCCESS) ;if library succeeded in loading
    or a
    ret z
;disables any user interrupts being used
    res 2,(iy+$23)
    ld a,$3c
    out (0),a    
;draws error string
    ld hl, 0
    ld (_curRow), hl
    ld hl, TI_LOADLERRSTRING
    call _puts
    jp _jforcecmdnochar
TI_LOADLERRSTRING:
    .db "Required Library was not found.", 0
DRAW16:
;ors an 16 pixel wide nonaligned sprite
    ld de,(SYSBYTEARG0)
    ld h, 0
    ld a,d
    add a,a
    add a,a
    ld l,a
    ld a,e
    rra
    add hl,hl
    rra
    add hl,hl
    rra
    or l
    ld l,a
    ld bc, (VIDEOBUFF)
    add hl,bc
    ld a,e
    and %00000111
    ld ix, (SYSPOINTERARG0)
    ld c, a
    ld a,(SPRITE16HEIGHT)
    ld b, a
ds2116lp:
    push bc
    ld a, c
    ld c, (ix+0)
    ld d, (ix+1)
    or a
    jr z, TI_D16_skiprotate
    ld b, a
    xor a
ds2116lp2:
    rr c
    rr d
    rra
    djnz ds2116lp2
TI_D16_skiprotate:
    ld b,a
    ld a,c
    or (hl)
    ld (hl),a
    inc hl
    ld a,d
    or (hl)
    ld (hl),a
    inc hl    
    ld a,b
    or (hl)
    ld (hl),a
    inc ix
    inc ix
    ld bc, 14
    add hl, bc
    pop bc
    djnz ds2116lp
    ret
DRAW1616:
    ld a, 16
    ld (SPRITE16HEIGHT), a
    jp DRAW16
; refer to DRAWWINDOW in 86windows.asm
; refer to DRAWWINDOW in 86windows.asm
; refer to DRAWWINDOW in 86windows.asm
; refer to DRAWWINDOW in 86windows.asm
; refer to HELPWINDOW in TIPwin86.asm
; refer to WINDOWMENU in TIPwin86.asm
TI_CP16:
	push hl
	or a
	sbc hl,de
	pop hl
	ret
;After about three hours of tweaking, I found this to be the most
;stable and effective way to read keys through the hardware (twice)
TI_GETKEY:
	ld a,b
	out (1), a
	in a,(1)
	and c
	ret z
	ld a,b
	out (1), a
	in a,(1)
	and c
	ret
TI_MAINTITLE:
	.db "TIPwin86 Library Example",0
TI_STRING0:
	.db "TIPwin86 Rocks!",0
TI_STRING1:
	.db "Sample",0
TI_STRING2:
	.db "Middle",0
TI_STRING3:
	.db "TIPwin86 Help",0
TI_ENDFILE:
SYSPOINTERARG0                           .equ $8100
SYSPOINTERARG1                           .equ $8102
SYSBYTEARG0                              .equ $8104
SYSBYTEARG1                              .equ $8105
SYSBYTEARG2                              .equ $8106
SYSBYTEARG3                              .equ $8107
SYSBYTEARG4                              .equ $8108
SUCCESS                                  .equ $8109
SPRITE8HEIGHT                            .equ $810a
SPRITE16HEIGHT                           .equ $810b
SYSWORDARG0                              .equ $810c
SYSWORDARG1                              .equ $810e
VIDEOBUFF                                .equ $8110
FREEMEM                                  .equ 33042
SCREENHEIGHT                             .equ 64
NUMSCREENBYTES                           .equ 1024
SCREENWIDTH                              .equ 128
SCREENWIDTHBYTES                         .equ 16
TIPWIN86SIZE                             .equ 1024
IDYES                                    .equ 1
IDNO                                     .equ 2
IDCANCEL                                 .equ 3
MB_OK                                    .equ 0
MB_YESNO                                 .equ 1
MB_YESNOCANCEL                           .equ 2
MB_NONE                                  .equ 3
