;----------------------------------------------
; TI-86 Keyboard equates
;----------------------------------------------
; Version 02/02/2000 by Clement Vasseur
; Report any error to <darkclem@wanadoo.fr>

;----------------------------------------------
; Scan codes (_getcsc and _GetKy)
;----------------------------------------------

K_NOKEY         equ     00h
K_DOWN          equ     01h
K_LEFT          equ     02h
K_RIGHT         equ     03h
K_UP            equ     04h
K_ENTER         equ     09h
K_PLUS          equ     0Ah
K_MINUS         equ     0Bh
K_STAR          equ     0Ch
K_SLASH         equ     0Dh
K_RAISE         equ     0Eh
K_CLEAR         equ     0Fh
K_SIGN          equ     11h
K_3             equ     12h
K_6             equ     13h
K_9             equ     14h
K_RIGHTPAR      equ     15h
K_TAN           equ     16h
K_CUSTOM        equ     17h
K_DOT           equ     19h
K_2             equ     1Ah
K_5             equ     1Bh
K_8             equ     1Ch
K_LEFTPAR       equ     1Dh
K_COS           equ     1Eh
K_PRGM          equ     1Fh
K_DEL           equ     20h
K_0             equ     21h
K_1             equ     22h
K_4             equ     23h
K_7             equ     24h
K_EE            equ     25h
K_SIN           equ     26h
K_TABLE         equ     27h
K_XVAR          equ     28h
K_ON            equ     29h     ;Huh ?!?
K_STO           equ     2Ah
K_COMMA         equ     2Bh
K_SQUARE        equ     2Ch
K_LN            equ     2Dh
K_LOG           equ     2Eh
K_GRAPH         equ     2Fh
K_ALPHA         equ     30h
K_F5            equ     31h
K_F4            equ     32h
K_F3            equ     33h
K_F2            equ     34h
K_F1            equ     35h
K_SECOND        equ     36h
K_EXIT          equ     37h
K_MORE          equ     38h

;----------------------------------------------
; _getkey scancodes
;----------------------------------------------

kRight          equ     001h
kLeft           equ     002h
kUp             equ     003h
kDown           equ     004h
kColon          equ     005h
kEnter          equ     006h
kExit           equ     007h
kClear          equ     008h
kDel            equ     009h
kIns            equ     00Ah
kNext           equ     00Bh
kAdd            equ     00Ch
kSub            equ     00Dh
kMul            equ     00Eh
kDiv            equ     00Fh
kExpon          equ     010h
kLParen         equ     011h
kRParen         equ     012h
kLBrack         equ     013h
kRBrack         equ     014h
kEqual          equ     015h
kStore          equ     016h
kRecall         equ     017h
kComma          equ     018h
kAng            equ     019h
kChs            equ     01Ah
kDecPnt         equ     01Bh
k0              equ     01Ch
k1              equ     01Dh
k2              equ     01Eh
k3              equ     01Fh
k4              equ     020h
k5              equ     021h
k6              equ     022h
k7              equ     023h
k8              equ     024h
k9              equ     025h
kEE             equ     026h
kSpace          equ     027h
kCapA           equ     028h
kCapB           equ     029h
kCapC           equ     02Ah
kCapD           equ     02Bh
kCapE           equ     02Ch
kCapF           equ     02Dh
kCapG           equ     02Eh
kCapH           equ     02Fh
kCapI           equ     030h
kCapJ           equ     031h
kCapK           equ     032h
kCapL           equ     033h
kCapM           equ     034h
kCapN           equ     035h
kCapO           equ     036h
kCapP           equ     037h
kCapQ           equ     038h
kCapR           equ     039h
kCapS           equ     03Ah
kCapT           equ     03Bh
kCapU           equ     03Ch
kCapV           equ     03Dh
kCapW           equ     03Eh
kCapX           equ     03Fh
kCapY           equ     040h
kCapZ           equ     041h
ka              equ     042h
kb              equ     043h
kc              equ     044h
kd              equ     045h
ke              equ     046h
kf              equ     047h
kg              equ     048h
kh              equ     049h
ki              equ     04Ah
kj              equ     04Bh
kk              equ     04Ch
kl              equ     04Dh
km              equ     04Eh
kn              equ     04Fh
ko              equ     050h
kp              equ     051h
kq              equ     052h
kr              equ     053h
ks              equ     054h
kt              equ     055h
ku              equ     056h
kv              equ     057h
kw              equ     058h
kx              equ     059h
ky              equ     05Ah
kz              equ     05Bh
kVarx           equ     05Ch
kAns            equ     05Dh
kPi             equ     05Eh
kInv            equ     05Fh
kSin            equ     060h
kASin           equ     061h
kCos            equ     062h
kACos           equ     063h
kTan            equ     064h
kATan           equ     065h
kSquare         equ     066h
kSqrt           equ     067h
kLn             equ     068h
kExp            equ     069h
kLog            equ     06Ah
kALog           equ     06Bh
kMath           equ     06Ch
kCplx           equ     06Dh
kString         equ     06Eh
kTest           equ     06Fh
kConv           equ     070h
kChar           equ     071h
kBase           equ     072h
kCustom         equ     073h
kVars           equ     074h
kCatalog        equ     075h
kQuit           equ     076h
kLastEnt        equ     077h
kLinkIO         equ     078h
kMem            equ     079h
kList           equ     07Ah
kVector         equ     07Bh
kConst          equ     07Ch
kMatrix         equ     07Dh
kPoly           equ     07Eh
kSimult         equ     07Fh
kStat           equ     080h
kGrMenu         equ     081h
kMode           equ     082h
kPrgm           equ     083h
kCalcu          equ     084h
kSolver         equ     085h
kTable          equ     086h
kBOL            equ     087h
kEOL            equ     088h
kCUSTM          equ     093h
kF1             equ     0C2h
kF2             equ     0C3h
kF3             equ     0C4h
kF4             equ     0C5h
kF5             equ     0C6h
kF6             equ     0C7h
kF7             equ     0C8h
kF8             equ     0C9h
kF9             equ     0CAh
kF10            equ     0CBh
kGRAPH          equ     0FFh

.end
