;----------------------------------------------
; TI-86 miscellaneous equates
;----------------------------------------------
; Version 02/02/2000 by Clement Vasseur
; Report any error to <darkclem@wanadoo.fr>

;----------------------------------------------
; TI-86 ports
;----------------------------------------------
scrnPort		equ		0		; screen port
kbdPort			equ		1		; keyboard port
contPort		equ		2		; contrast port
intrptPort		equ		3		; interrupt port
iAll			equ		11		; interrupts on, lcd on
bPort			equ		7		; 4-bit link port (I/O)
D0lD1l			equ		$FC		; D0 low  D1 low
D0lD1h			equ		$D4		; D0 low  D1 high
D0hD1l			equ		$E8		; D0 high D1 low
D0hD1h			equ		$C0		; D0 high D1 high

;----------------------------------------------
; Context states
;----------------------------------------------
cxHome			equ		$01		; home screen
cxPoly			equ		$02		; polynomial solver
cxSimult		equ		$03		; simultaneous equation solver
cxSolver		equ		$04		; numerical solver
cxConsEdit		equ		$05		; constant editor
cxVectEdit		equ		$06		; vector editor
cxMatEdit		equ		$07		; matrix editor
cxPrgmEdit		equ		$08		; program editor
cxStatEdit		equ		$0E		; statistics list editor
cxInter			equ		$0F		; interpolate/extrapolate editor
cxTol			equ		$12		; tolerance editor
cxPrgmInput		equ		$15		; programmed input
cxTableEditor	equ		$19		; table editor
cxTableSet		equ		$1A		; table setup
cxLinkIO		equ		$1B		; link I/O interface
cxMem			equ		$1D		; reset memory
cxDefMem		equ		$1E		; reset default
cxAll			equ		$1F		; reset all
cxRAM			equ		$20		; RAM usage screen
cxMode			equ		$21		; mode settings screen
cxErase			equ		$23		; memory erase
cxStatPlot		equ		$25		; stat plots
cxFuncEdit		equ		$49		; y(x)= editor
cxWind			equ		$4A		; window editor
cxGrZfact		equ		$4B		; graph zoom factors editor
cxGraph			equ		$4C		; graph mode
cxIntCond		equ		$53		; initial conditions prompt
cxForm			equ		$62		; graph format
cxCatlg			equ		$96		; catlg-vars
cxError			equ		$98		; error handler

;----------------------------------------------
; Misc
;----------------------------------------------

tExtend			equ		$8E		; extend token
txAsmCmp		equ		$28		; compiled asm token

lcdMem			equ		$FC00	; Video ram
lcdWide			equ		16
lcdTall			equ		64

fpLen			equ		10		; length of a floating-point number

busyPause		equ		%10101010
busyNormal		equ		%11110000

.end
